% renders surfaces in 3d

% needs matrix3d.inc

% a surface is an array of faces
% a face = [ polygon + normal ]
% a polygon = array of vertices

% affine transformation A + a surface s => transformed surface

/surface-transform {
4 dict begin
/s exch def
[
  s {
  /f exch def
  /p f 0 get def
  /n f 1 get def
  [
    [
      p {
        A exch affine-transform-3d
      } forall
    ]
    A 0 get n transform-3d 
  ]
  } forall
]
end
} def

% face

/is-visible-in-projection {
1 get 2 get 0 gt {
  true
} {
  false
} ifelse
} def

% face

/is-visible-in-perspective {
1 dict begin
/f exch def
  f 0 get 0 get 
  f 1 get
  dot-product-3d 
0 lt {
  true
} {
  false
} ifelse
end
} def

% [x y z] => [x y]

/projection {
1 dict begin
/v exch def
[v 0 get v 1 get]
end
} def

% [x y z] => [-x/z -y/z]

/perspective {
2 dict begin
/v exch def
/z v 2 get neg def
[v 0 get z div v 1 get z div]
end
} def

% ----------------------------------------------------

/light-source [-1 1 0.5] normalize-3d def

% normal

/minshade 0.05 def
/maxshade 0.95 def
/shadefactor maxshade minshade sub 4 div def

/shading {
2 dict begin
/n exch def
/d n light-source dot-product-3d 
def
maxshade minshade add 0.5 mul
maxshade minshade sub 0.5 mul 
d mul add
end
} def

% pars /f [si ti] [tf sf] [ns nt] => surface parametrized by f 
% and range [si sf] x [ti tf] - get ns x nt rectangles
% f: pars [s t] => f(s, t)

/mksurface {
16 dict begin
aload pop
/nt exch def
/ns exch def
aload pop
/tf exch def
/sf exch def
aload pop
/ti exch def
/si exch def
/f exch cvx def
/pars exch def
/sinc sf si sub ns div def
/tinc tf ti sub nt div def

[
  /s si def
  ns {
    /t ti def
    nt {
[s t] ==
      % make the f(s, t) face
      /ll pars [s          t         ] f def
      /lr pars [s sinc add t         ] f def
      /ur pars [s sinc add t tinc add] f def
      /ul pars [s          t tinc add] f def
      [
      [
        ll lr ur ul ll
      ]
      /n lr ll vector-sub-3d
        ul ll vector-sub-3d
        cross-product 
      def
      /r n vector-length-3d def
      r 0 ne {
        /n n 1 r div vector-scale-3d def
      } {
        /n ur lr vector-sub-3d
          ur ul vector-sub-3d
          cross-product 
        def
        /r n vector-length-3d def
        r 0 ne {
          /n n 1 r div vector-scale-3d def
        } {
          /n [0 0 1] def
        } ifelse
      } ifelse 
      n ]
      /t t tinc add def
    } repeat
    /s s sinc add def
  } repeat

]

end
} def

% - end of draw3d.inc -------------------------------

